with Interfaces; use Interfaces;

package body CosNotifyChannelAdmin_ProxyPushConsumer_Hash is

   P : constant array (0 .. 3) of Natural :=
     (1, 4, 8, 10);

   T1 : constant array (0 .. 3) of Unsigned_8 :=
     (31, 34, 24, 42);

   T2 : constant array (0 .. 3) of Unsigned_8 :=
     (39, 24, 13, 8);

   G : constant array (0 .. 42) of Unsigned_8 :=
     (17, 0, 0, 15, 0, 12, 20, 0, 18, 0, 8, 0, 9, 0, 6, 0, 0, 0, 0, 5, 0, 2,
      0, 0, 0, 20, 19, 3, 0, 0, 19, 10, 0, 13, 0, 0, 10, 0, 19, 0, 0, 13,
      11);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 43;
         F2 := (F2 + Natural (T2 (K)) * J) mod 43;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 21;
   end Hash;

end CosNotifyChannelAdmin_ProxyPushConsumer_Hash;
